"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = _interopRequireDefault(require("material-ui/Button"));

var _styles = require("material-ui/styles");

var _Add = _interopRequireDefault(require("material-ui-icons/Add"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

var styles = function styles(theme) {
  return {
    button: {},
    icon: {
      width: 48,
      height: 48
    },
    primaryText: {
      fontSize: 'medium'
    },
    secondaryText: {
      fontSize: 'x-small'
    }
  };
};

var Dropper = function Dropper(_ref) {
  var classes = _ref.classes,
      className = _ref.className,
      _ref$icon = _ref.icon,
      Icon = _ref$icon === void 0 ? _Add.default : _ref$icon,
      _ref$primaryText = _ref.primaryText,
      primaryText = _ref$primaryText === void 0 ? 'Add' : _ref$primaryText,
      _ref$secondaryText = _ref.secondaryText,
      secondaryText = _ref$secondaryText === void 0 ? 'Drop files here' : _ref$secondaryText,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'primary' : _ref$color,
      props = _objectWithoutProperties(_ref, ["classes", "className", "icon", "primaryText", "secondaryText", "color"]);

  return _react.default.createElement(_Button.default, _extends({}, props, {
    className: (0, _classnames.default)(classes.button, className),
    variant: "raised",
    color: color
  }), _react.default.createElement("div", null, _react.default.createElement(Icon, {
    className: classes.icon
  }), _react.default.createElement("div", {
    className: classes.primaryText
  }, primaryText), _react.default.createElement("div", {
    className: classes.secondaryText
  }, secondaryText)));
};

Dropper.propTypes = {
  classes: _propTypes.default.object,
  className: _propTypes.default.string,
  icon: _propTypes.default.func,
  primaryText: _propTypes.default.string,
  secondaryText: _propTypes.default.string
};

var _default = (0, _styles.withStyles)(styles)(Dropper);

exports.default = _default;