"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _reactDropzone = _interopRequireDefault(require("react-dropzone"));

var _styles = require("material-ui/styles");

var _Dropper = _interopRequireDefault(require("./Dropper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var styles = function styles(theme) {
  return {
    tiles: {
      display: 'flex'
    },
    tile: {
      width: 128,
      height: 128
    },
    hidden: {
      display: 'none'
    },
    dropper: {}
  };
};

var FileInput =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FileInput, _React$Component);

  function FileInput() {
    var _ref;

    var _temp, _this;

    _classCallCheck(this, FileInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_ref = FileInput.__proto__ || Object.getPrototypeOf(FileInput)).call.apply(_ref, [this].concat(args))), Object.defineProperty(_assertThisInitialized(_this), "handleAdd", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(filesAccepted) {
        var _this$props = _this.props,
            onChange = _this$props.onChange,
            maxItems = _this$props.maxItems,
            transform = _this$props.transform;
        filesAccepted = filesAccepted.slice(0, maxItems).map(transform);
        onChange(filesAccepted);
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handleRemove", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(file) {
        var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props,
            _value = _ref2.value,
            onChange = _ref2.onChange;

        onChange(_value.filter(function (f) {
          return f !== file;
        }));
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "createHandleRemove", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(file) {
        return function (event) {
          event.stopPropagation();

          _this.handleRemove(file);
        };
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "renderPreview", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(file, index, array) {
        var _ref3 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _this.props,
            children = _ref3.children,
            classes = _ref3.classes;

        // First lookup the applicable child
        var previewComponent = _react.default.Children.toArray(children).find(function (_ref4) {
          var accept = _ref4.props.accept;
          return accept(file);
        });

        return previewComponent ? _react.default.cloneElement(previewComponent, {
          key: "preview-".concat(file.name),
          file: file,
          index: index,
          className: classes.tile,
          onRemove: _this.createHandleRemove(file)
        }) : null;
      }
    }), _temp));
  }

  _createClass(FileInput, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          DropperComponent = _props.dropperComponent,
          dropperProps = _props.dropperProps,
          maxItems = _props.maxItems,
          value = _props.value;
      var shouldHideDropzone = value.length >= maxItems;
      return _react.default.createElement("div", {
        className: classes.tiles
      }, value.map(this.renderPreview), _react.default.createElement(_reactDropzone.default, {
        disablePreview: true,
        multiple: maxItems > 1,
        onDrop: this.handleAdd,
        className: (0, _classnames2.default)(classes.tile, _defineProperty({}, classes.hidden, shouldHideDropzone))
      }, _react.default.createElement(DropperComponent, _extends({}, dropperProps, {
        className: (0, _classnames2.default)(classes.tile, classes.dropper)
      }))));
    }
  }]);

  return FileInput;
}(_react.default.Component);

Object.defineProperty(FileInput, "propTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    dropperProps: _propTypes.default.object,
    dropperComponent: _propTypes.default.func,
    maxItems: _propTypes.default.number.isRequired,
    previewRenderer: _propTypes.default.func,
    classes: _propTypes.default.object,
    tileSize: _propTypes.default.number,
    tileWidth: _propTypes.default.number,
    tileHeight: _propTypes.default.number,
    transform: _propTypes.default.func,
    onChange: _propTypes.default.func.isRequired,
    value: _propTypes.default.arrayOf(_propTypes.default.shape({
      rawFile: _propTypes.default.instanceOf(File),
      name: _propTypes.default.string
    })).isRequired
  }
});
Object.defineProperty(FileInput, "defaultProps", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    transform: function transform(a) {
      return a;
    },
    dropperComponent: _Dropper.default,
    value: []
  }
});

var _default = (0, _styles.withStyles)(styles)(FileInput);

exports.default = _default;