"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Modal = _interopRequireDefault(require("material-ui/Modal"));

var _styles = require("material-ui/styles");

var _classnames = _interopRequireDefault(require("classnames"));

var _Progress = require("material-ui/Progress");

var _reactMaterialCropperjs = _interopRequireDefault(require("@tkvw/react-material-cropperjs"));

var _reactImageTransformation = _interopRequireDefault(require("@tkvw/react-image-transformation"));

var _reactMaterialImage = _interopRequireDefault(require("@tkvw/react-material-image"));

var _Preview = _interopRequireDefault(require("./Preview"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

var styles = function styles(theme) {
  return {
    image: {
      width: '100%',
      cursor: 'pointer'
    },
    imageSrc: {
      position: 'absolute',
      left: 0,
      right: 0,
      top: 0,
      bottom: 0,
      backgroundSize: 'cover',
      backgroundPosition: 'center 40%'
    },
    cropperEditor: {
      width: '100%'
    }
  };
};

var sanitizeProps = function sanitizeProps(_ref) {
  var accept = _ref.accept,
      imageTransformationOptions = _ref.imageTransformationOptions,
      maxItems = _ref.maxItems,
      previewTransformationOptions = _ref.previewTransformationOptions,
      rest = _objectWithoutProperties(_ref, ["accept", "imageTransformationOptions", "maxItems", "previewTransformationOptions"]);

  return rest;
};

var FileImagePreview =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FileImagePreview, _React$Component);

  function FileImagePreview() {
    var _ref2;

    var _temp, _this;

    _classCallCheck(this, FileImagePreview);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_ref2 = FileImagePreview.__proto__ || Object.getPrototypeOf(FileImagePreview)).call.apply(_ref2, [this].concat(args))), Object.defineProperty(_assertThisInitialized(_this), "handleCropImage", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(cropper, updateBlob, closePreview) {
        cropper.getCroppedCanvas().toBlob(updateBlob, 'image/jpeg', 1);
        closePreview();
      }
    }), _temp));
  }

  _createClass(FileImagePreview, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          classes = _props.classes,
          className = _props.className,
          cropperOptions = _props.cropperOptions,
          file = _props.file,
          getFile = _props.getFile,
          imageTransformationOptions = _props.imageTransformationOptions,
          previewTransformationOptions = _props.previewTransformationOptions,
          onRemove = _props.onRemove,
          props = _objectWithoutProperties(_props, ["classes", "className", "cropperOptions", "file", "getFile", "imageTransformationOptions", "previewTransformationOptions", "onRemove"]);

      return _react.default.createElement(_reactImageTransformation.default, {
        src: getFile(file),
        options: _extends({
          conversion: ['image/jpeg', 0.95]
        }, imageTransformationOptions),
        render: function render(_ref3) {
          var image = _ref3.blob,
              updateBlob = _ref3.updateBlob;
          file.image = image;
          return _react.default.createElement(_reactImageTransformation.default, {
            src: image,
            options: _extends({
              conversion: ['image/jpeg', 0.8]
            }, previewTransformationOptions),
            render: function render(_ref4) {
              var preview = _ref4.blob;
              file.preview = preview;
              return _react.default.createElement(_Preview.default, {
                className: className,
                onRemove: onRemove,
                renderViewer: function renderViewer(_ref5) {
                  var closePreview = _ref5.closePreview;
                  return _react.default.createElement(_reactMaterialCropperjs.default, {
                    className: classes.cropperEditor,
                    cropperOptions: cropperOptions,
                    src: image,
                    onSelect: function onSelect(cropper) {
                      return _this2.handleCropImage(cropper, updateBlob, closePreview);
                    }
                  });
                }
              }, _react.default.createElement(_reactMaterialImage.default, {
                src: preview
              }));
            }
          });
        }
      });
    }
  }]);

  return FileImagePreview;
}(_react.default.Component);

Object.defineProperty(FileImagePreview, "propTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    accept: _propTypes.default.func,
    className: _propTypes.default.string,
    classes: _propTypes.default.object,
    imageTransformationOptions: _propTypes.default.object,
    previewTransformationOptions: _propTypes.default.object,
    cropperOptions: _propTypes.default.object,
    getFile: _propTypes.default.func.isRequired,
    file: _propTypes.default.shape({
      rawFile: _propTypes.default.any.isRequired
    }).isRequired
  }
});
Object.defineProperty(FileImagePreview, "defaultProps", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    cropperOptions: {
      aspectRatio: 1
    },
    imageTransformationOptions: {
      maxWidth: 1920
    },
    previewTransformationOptions: {
      maxWidth: 256,
      maxHeight: 256
    }
  }
});

var _default = (0, _styles.withStyles)(styles)(FileImagePreview);

exports.default = _default;