"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Preview = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Modal = _interopRequireDefault(require("material-ui/Modal"));

var _Button = _interopRequireDefault(require("material-ui/Button"));

var _RemoveCircle = _interopRequireDefault(require("material-ui-icons/RemoveCircle"));

var _styles = require("material-ui/styles");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var styles = function styles(theme) {
  return {
    root: {
      width: 128,
      height: 128
    },
    button: {
      width: '100%',
      height: '100%',
      position: 'relative',
      display: 'flex',
      alignItems: 'center',
      padding: 0
    },
    buttonLabel: {
      height: '100%'
    },
    modal: {
      display: 'flex',
      alignItems: 'center',
      position: 'absolute',
      top: '50%',
      left: '50%',
      transform: "translate(-50%,-50%)",
      backgroundColor: theme.palette.background.paper,
      boxShadow: theme.shadows[5],
      width: '80%',
      padding: theme.spacing.unit * 4
    },
    remove: {
      position: 'absolute',
      padding: 5,
      right: 0,
      top: 0,
      color: theme.palette.secondary.main
    }
  };
};

var Preview =
/*#__PURE__*/
function (_Component) {
  _inherits(Preview, _Component);

  function Preview() {
    var _ref;

    var _temp, _this;

    _classCallCheck(this, Preview);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_ref = Preview.__proto__ || Object.getPrototypeOf(Preview)).call.apply(_ref, [this].concat(args))), Object.defineProperty(_assertThisInitialized(_this), "state", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {
        showPreview: false
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handleRemove", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(event) {
        var _this$props = _this.props,
            file = _this$props.file,
            onRemove = _this$props.onRemove;
        event.stopPropagation();
        onRemove && onRemove(file);
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handlePreviewClose", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value() {
        _this.setState({
          showPreview: false
        });
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handlePreviewOpen", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value() {
        var _this$props2 = _this.props,
            onClick = _this$props2.onClick,
            renderViewer = _this$props2.renderViewer;
        onClick && onClick(event);

        _this.setState({
          showPreview: !!renderViewer
        });
      }
    }), _temp));
  }

  _createClass(Preview, [{
    key: "render",
    value: function render() {
      var showPreview = this.state.showPreview;
      var _props = this.props,
          children = _props.children,
          _props$classes = _props.classes,
          classes = _props$classes === void 0 ? {} : _props$classes,
          className = _props.className,
          onRemove = _props.onRemove,
          renderViewer = _props.renderViewer;
      return _react.default.createElement("div", {
        className: (0, _classnames.default)(classes.root, className)
      }, _react.default.createElement(_Button.default, {
        classes: {
          label: classes.buttonLabel
        },
        className: classes.button,
        component: "div",
        variant: "raised",
        onClick: this.handlePreviewOpen
      }, _react.default.createElement(_RemoveCircle.default, {
        className: classes.remove,
        onClick: onRemove
      }), children), _react.default.createElement(_Modal.default, {
        open: showPreview,
        onClose: this.handlePreviewClose
      }, _react.default.createElement("div", {
        className: classes.modal
      }, renderViewer && renderViewer({
        closePreview: this.handlePreviewClose
      }))));
    }
  }]);

  return Preview;
}(_react.Component);

exports.Preview = Preview;
Object.defineProperty(Preview, "propTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    onClick: _propTypes.default.func,
    children: _propTypes.default.node,
    classes: _propTypes.default.object,
    className: _propTypes.default.string,
    file: _propTypes.default.object,
    onRemove: _propTypes.default.func.isRequired
  }
});
Preview.defaultProps = {
  file: undefined
};

var _default = (0, _styles.withStyles)(styles)(Preview);

exports.default = _default;